/*
 * GMS REST API
 * Date: 2019-06-28 10:13:53 | Number of web services: 176
 *
 * OpenAPI spec version: 3.1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.LinkDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * CustomerDto
 */

public class CustomerDto {

  @SerializedName("maxUsers")
  private Integer maxUsers = null;

  @SerializedName("maxEndDevices")
  private Integer maxEndDevices = null;

  @SerializedName("maxGateways")
  private Integer maxGateways = null;

  @SerializedName("geolocationExpirationDate")
  private Long geolocationExpirationDate = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("logo")
  private String logo = null;

  @SerializedName("links")
  private List<LinkDto> links = null;

  @SerializedName("geolocationAuthorized")
  private Boolean geolocationAuthorized = null;

  @SerializedName("id")
  private Long id = null;

  @SerializedName("billing")
  private Boolean billing = null;
  public CustomerDto maxUsers(Integer maxUsers) {
    this.maxUsers = maxUsers;
    return this;
  }

  

  /**
  * Maximum number of users attached to the customer
  * @return maxUsers
  **/
  @Schema(description = "Maximum number of users attached to the customer")
  public Integer getMaxUsers() {
    return this.maxUsers;
  }
  public void setMaxUsers(Integer maxUsers) {
    this.maxUsers = maxUsers;
  }
  public CustomerDto maxEndDevices(Integer maxEndDevices) {
    this.maxEndDevices = maxEndDevices;
    return this;
  }

  

  /**
  * Maximum number of endDevices attached to the customer
  * @return maxEndDevices
  **/
  @Schema(description = "Maximum number of endDevices attached to the customer")
  public Integer getMaxEndDevices() {
    return this.maxEndDevices;
  }
  public void setMaxEndDevices(Integer maxEndDevices) {
    this.maxEndDevices = maxEndDevices;
  }
  public CustomerDto maxGateways(Integer maxGateways) {
    this.maxGateways = maxGateways;
    return this;
  }

  

  /**
  * Maximum number of gateways attached to the customer
  * @return maxGateways
  **/
  @Schema(description = "Maximum number of gateways attached to the customer")
  public Integer getMaxGateways() {
    return this.maxGateways;
  }
  public void setMaxGateways(Integer maxGateways) {
    this.maxGateways = maxGateways;
  }
  public CustomerDto geolocationExpirationDate(Long geolocationExpirationDate) {
    this.geolocationExpirationDate = geolocationExpirationDate;
    return this;
  }

  

  /**
  * The expiration date of the geolocation functionality
  * @return geolocationExpirationDate
  **/
  @Schema(description = "The expiration date of the geolocation functionality")
  public Long getGeolocationExpirationDate() {
    return this.geolocationExpirationDate;
  }
  public void setGeolocationExpirationDate(Long geolocationExpirationDate) {
    this.geolocationExpirationDate = geolocationExpirationDate;
  }
  public CustomerDto name(String name) {
    this.name = name;
    return this;
  }

  

  /**
  * Name
  * @return name
  **/
  @Schema(required = true, description = "Name")
  public String getName() {
    return this.name;
  }
  public void setName(String name) {
    this.name = name;
  }
  public CustomerDto logo(String logo) {
    this.logo = logo;
    return this;
  }

  

  /**
  * Logo URL
  * @return logo
  **/
  @Schema(description = "Logo URL")
  public String getLogo() {
    return this.logo;
  }
  public void setLogo(String logo) {
    this.logo = logo;
  }
  public CustomerDto links(List<LinkDto> links) {
    this.links = links;
    return this;
  }

  public CustomerDto addLinksItem(LinkDto linksItem) {
    if (this.links == null) {
      this.links = new ArrayList<LinkDto>();
    }
    this.links.add(linksItem);
    return this;
  }

  /**
  * clusters, fleets, gateways, rncKpis, self
  * @return links
  **/
  @Schema(description = "clusters, fleets, gateways, rncKpis, self")
  public List<LinkDto> getLinks() {
    return this.links;
  }
  public void setLinks(List<LinkDto> links) {
    this.links = links;
  }
  public CustomerDto geolocationAuthorized(Boolean geolocationAuthorized) {
    this.geolocationAuthorized = geolocationAuthorized;
    return this;
  }

  

  /**
  * Authorization for the the customer to manage the geolocalisation functionality
  * @return geolocationAuthorized
  **/
  @Schema(description = "Authorization for the the customer to manage the geolocalisation functionality")
  public Boolean isGeolocationAuthorized() {
    return geolocationAuthorized;
  }
  public void setGeolocationAuthorized(Boolean geolocationAuthorized) {
    this.geolocationAuthorized = geolocationAuthorized;
  }
  public CustomerDto id(Long id) {
    this.id = id;
    return this;
  }

  

  /**
  * Identifier
  * @return id
  **/
  @Schema(required = true, description = "Identifier")
  public Long getId() {
    return this.id;
  }
  public void setId(Long id) {
    this.id = id;
  }
  public CustomerDto billing(Boolean billing) {
    this.billing = billing;
    return this;
  }

  

  /**
  * Indicator for producing the billing data of the customer
  * @return billing
  **/
  @Schema(description = "Indicator for producing the billing data of the customer")
  public Boolean isBilling() {
    return billing;
  }
  public void setBilling(Boolean billing) {
    this.billing = billing;
  }
  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CustomerDto customerDto = (CustomerDto) o;
    return Objects.equals(this.maxUsers, customerDto.maxUsers) &&
        Objects.equals(this.maxEndDevices, customerDto.maxEndDevices) &&
        Objects.equals(this.maxGateways, customerDto.maxGateways) &&
        Objects.equals(this.geolocationExpirationDate, customerDto.geolocationExpirationDate) &&
        Objects.equals(this.name, customerDto.name) &&
        Objects.equals(this.logo, customerDto.logo) &&
        Objects.equals(this.links, customerDto.links) &&
        Objects.equals(this.geolocationAuthorized, customerDto.geolocationAuthorized) &&
        Objects.equals(this.id, customerDto.id) &&
        Objects.equals(this.billing, customerDto.billing);
  }

  @Override
  public int hashCode() {
    return java.util.Objects.hash(maxUsers, maxEndDevices, maxGateways, geolocationExpirationDate, name, logo, links, geolocationAuthorized, id, billing);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CustomerDto {\n");
    
    sb.append("    maxUsers: ").append(toIndentedString(maxUsers)).append("\n");
    sb.append("    maxEndDevices: ").append(toIndentedString(maxEndDevices)).append("\n");
    sb.append("    maxGateways: ").append(toIndentedString(maxGateways)).append("\n");
    sb.append("    geolocationExpirationDate: ").append(toIndentedString(geolocationExpirationDate)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    logo: ").append(toIndentedString(logo)).append("\n");
    sb.append("    links: ").append(toIndentedString(links)).append("\n");
    sb.append("    geolocationAuthorized: ").append(toIndentedString(geolocationAuthorized)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    billing: ").append(toIndentedString(billing)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

  public CustomerDto toId() {
	  CustomerDto customerDto = new CustomerDto();
	  customerDto.setId(this.getId());
	  return customerDto;
  }

}
